#include <windows.h>
#include <stdio.h>
#include <dos.h>
#include "dpmi.h"

typedef struct
{
  unsigned midInfoLevel;
  unsigned long midSerialNum;
  char midVolLabel[11];
  char midFileSysType[8];
} MID, FAR *LPMID;

unsigned long GetSerialNumber(int drive)
{
  DPMIREGS regs;
  DWORD DosMem;
  unsigned long serial;

  if ((DosMem = GlobalDosAlloc(sizeof(MID))) != NULL)
  {
    regs.AX = 0x440D;
    regs.BX = drive;
    regs.CX = 0x0866;
    regs.DX = 0;
    regs.DS = HIWORD(DosMem);
    SimulateRealModeInt(0x21, 0x80, &regs);
    serial = ((LPMID) MAKELP(LOWORD(DosMem), 0))->midSerialNum;
    GlobalDosFree(LOWORD(DosMem));
    return serial;
  }
  return 0;
}

#pragma argsused
int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  LPWORD BIOSData;
  int x;
  unsigned long serial;

  _InitEasyWin();
  serial = GetSerialNumber(3); 
  printf("Drive C serial number is %04X-%04X\n\n", HIWORD(serial), LOWORD(serial));
  if ((BIOSData = (LPWORD) AllocDOSAlias(0x40, 0x00)) != NULL)
  {
    for (x = 0; x < 4; x++)
      printf("COM%d = %04X  LPT%d = %04X\n", x+1, BIOSData[x], x+1, BIOSData[x+4]);
    FreeDOSAlias(BIOSData);
  } else {
    printf("DPMI Error - Unable to allocate DOS alias");
  }
  return 0;
}
